using FluentValidation;
using CMSMicroservice.Protobuf.Protos.ProductTag;
namespace CMSMicroservice.Protobuf.Validator.ProductTag;

public class GetAllProductTagByFilterRequestValidator : AbstractValidator<GetAllProductTagByFilterRequest>
{
    public GetAllProductTagByFilterRequestValidator()
    {
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetAllProductTagByFilterRequest>.CreateWithOptions((GetAllProductTagByFilterRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
